{Marinel Serban}
{100 puncte}
PROGRAM Factori;

CONST MAX = 60000;

Var N: LongInt;
    Prime: Array[1..MAX] Of Boolean;
    Fin, Fout: Text;

Procedure TabelPrime;                    {ciurul lui Eratostene}
Var i,j: LongInt;
    Radical: Real;
Begin
  For i := 1 To MAX Do Prime[i] := TRUE; {marcam toate ca fiind prime}
  Radical := Sqrt(MAX);                  {mergem pana la radical din MAX}
  i := 1;                                {plec de la inceputul vectorului}
  While i <= Radical Do                  {cat timp nu am terminat}
    Begin
      Repeat Inc(i) Until Prime[i];      {caut primul numar prim}
      j := i * i;                        {primul numar care nu mai este prim este patratul lui}
      While j <= MAX Do                  {apoi plecand de la el}
        Begin
          Prime[j] := FALSE;             {il marchez ca fiind neprim (este multiplu de i)}
          j := j + i                     {si merg din i in i si marchez}
        End;
    End;  {while i <= radical}
End;  {Tabel Prime}

Function CitesteNumar: Boolean;
Begin
  ReadLn(Fin, N);
  CitesteNumar := N<>0;
End;

Function Descompune(N, d: LongInt): LongInt;
Var s: LongInt;
Begin
{  If N < d Then            (*varianta recursiva*)
    Descompune := 0
  Else
    Descompune := N DIV d + Descompune(N DIV d, d);   }
  s := 0;               {initializez contorul cu 0}
  While N>=d Do         {cat timp d mai poate sa apara}
    Begin
      s := s + N DIV d; {d apare de N DIV d ori, le numar}
      N := N DIV d      {elimin aceste aparitii}
    End;
  Descompune := s
End;

Procedure Rezolva;
Var i: LongInt;
Begin
  i := 2;                                {plec de la 2}
  While NOT (Prime[i]) Do Inc(i);        {determin primul numar prim}
  Write(Fout, Descompune(N, i));         {determin de cate ori apare acesta in factorial}
  For i := i+1 To N Do                   {determin pe rand celelalte numere prime<N}
    If Prime[i] Then Write(Fout, ' ', Descompune(N,i)); {afisez un spatiu apoi numarul de }
  Writeln(Fout);                                        {aparitii a acestuia in factorial}
End;

Begin
  Assign(Fin, 'factori.in'); Reset(Fin);
  Assign(Fout, 'factori.out'); ReWrite(Fout);
  TabelPrime;             {generez tabela numerelor prime}
  While CitesteNumar Do   {cat timp nu am citit valoarea 0}
    Rezolva;              {descompune numarul}
  Close(Fin);
  Close(Fout);
End. 
